#[doc = "Register `CLK_IMO_TRIM3` reader"]
pub struct R(crate::R<CLK_IMO_TRIM3_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<CLK_IMO_TRIM3_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<CLK_IMO_TRIM3_SPEC>> for R {
    fn from(reader: crate::R<CLK_IMO_TRIM3_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `CLK_IMO_TRIM3` writer"]
pub struct W(crate::W<CLK_IMO_TRIM3_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<CLK_IMO_TRIM3_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<CLK_IMO_TRIM3_SPEC>> for W {
    fn from(writer: crate::W<CLK_IMO_TRIM3_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `TRIM_CLK36` reader - Trim bits for 36MHz oscillator. Typically stored in SFLASH and copied here on boot."]
pub struct TRIM_CLK36_R(crate::FieldReader<u8, u8>);
impl TRIM_CLK36_R {
    pub(crate) fn new(bits: u8) -> Self {
        TRIM_CLK36_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for TRIM_CLK36_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `TRIM_CLK36` writer - Trim bits for 36MHz oscillator. Typically stored in SFLASH and copied here on boot."]
pub struct TRIM_CLK36_W<'a> {
    w: &'a mut W,
}
impl<'a> TRIM_CLK36_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x0f) | (value as u32 & 0x0f);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:3 - Trim bits for 36MHz oscillator. Typically stored in SFLASH and copied here on boot."]
    #[inline(always)]
    pub fn trim_clk36(&self) -> TRIM_CLK36_R {
        TRIM_CLK36_R::new((self.bits & 0x0f) as u8)
    }
}
impl W {
    #[doc = "Bits 0:3 - Trim bits for 36MHz oscillator. Typically stored in SFLASH and copied here on boot."]
    #[inline(always)]
    pub fn trim_clk36(&mut self) -> TRIM_CLK36_W {
        TRIM_CLK36_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "IMO Trim Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [clk_imo_trim3](index.html) module"]
pub struct CLK_IMO_TRIM3_SPEC;
impl crate::RegisterSpec for CLK_IMO_TRIM3_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [clk_imo_trim3::R](R) reader structure"]
impl crate::Readable for CLK_IMO_TRIM3_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [clk_imo_trim3::W](W) writer structure"]
impl crate::Writable for CLK_IMO_TRIM3_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets CLK_IMO_TRIM3 to value 0"]
impl crate::Resettable for CLK_IMO_TRIM3_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
